/* ------------------------------------------------------------
 * Simple Example to Call Vnano Engine from an Application.
 * (Distributed under the CC0)
 * ------------------------------------------------------------
 * Compile:
 * 
 *     javac ApplicationExample.java
 * 
 * Run:
 * 
 *     java -cp ".;Vnano.jar" ApplicationExample
 * 
 *     or,
 * 
 *     java -cp ".:Vnano.jar" ApplicationExample
 * 
 * ------------------------------------------------------------ */

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class ApplicationExample {

    public static void main(String[] args) {

        // Get ScriptEngine of Vnano from ScriptEngineManager.
        ScriptEngine engine = new ScriptEngineManager().getEngineByName("vnano");
        if (engine == null) {
            System.err.println("Script engine not found.");
            return;
        }

        // Load library scripts and plug-ins, if necessary
        //engine.put("___VNANO_LIBRARY_LIST_FILE", "lib/VnanoLibraryList.txt");
        //engine.put("___VNANO_PLUGIN_LIST_FILE", "plugin/VnanoPluginList.txt");

        // Run the script code to calculate "1.2 + 3.4" on the script engine of Vnano.
        try{
            double x = (double) engine.eval("1.2 + 3.4 ;");
            System.out.println("Result: " + x);

        } catch (ScriptException e) {
            e.printStackTrace();
        }

    	// Unload library scripts and plug-ins, if necessary
        //engine.put("___VNANO_COMMAND", "REMOVE_LIBRARY");
        //engine.put("___VNANO_COMMAND", "REMOVE_PLUGIN");
    }
}
